"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread"));

var _stringify = _interopRequireDefault(require("@babel/runtime/core-js/json/stringify"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _utils = require("./utils");

var sendCommand =
/*#__PURE__*/
function () {
  var _ref2 = (0, _asyncToGenerator2.default)(
  /*#__PURE__*/
  _regenerator.default.mark(function _callee(_ref, action) {
    var origin, rootPath, store, command, aggregateId, aggregateName, payload, normalizedCommand, response, text;
    return _regenerator.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            origin = _ref.origin, rootPath = _ref.rootPath, store = _ref.store;
            command = action.command, aggregateId = action.aggregateId, aggregateName = action.aggregateName, payload = action.payload;

            if (command && (0, _utils.checkRequiredFields)({
              aggregateId: aggregateId,
              aggregateName: aggregateName
            }, 'Send command error:', (0, _stringify.default)(action)) && !(command.ok || command.error)) {
              _context.next = 4;
              break;
            }

            return _context.abrupt("return");

          case 4:
            normalizedCommand = {
              type: command.type,
              aggregateId: aggregateId,
              aggregateName: aggregateName,
              payload: payload
            };
            _context.prev = 5;
            _context.next = 8;
            return fetch((0, _utils.getRootBasedUrl)(origin, rootPath, '/api/commands'), {
              method: 'POST',
              headers: {
                'Content-Type': 'application/json'
              },
              credentials: 'same-origin',
              body: (0, _stringify.default)(normalizedCommand)
            });

          case 8:
            response = _context.sent;

            if (!response.ok) {
              _context.next = 12;
              break;
            }

            store.dispatch((0, _objectSpread2.default)({}, action, {
              command: (0, _objectSpread2.default)({}, action.command, {
                ok: true
              })
            }));
            return _context.abrupt("return");

          case 12:
            _context.next = 14;
            return response.text();

          case 14:
            text = _context.sent;
            // eslint-disable-next-line no-console
            console.error('Send command error:', text);
            throw new Error(text);

          case 19:
            _context.prev = 19;
            _context.t0 = _context["catch"](5);
            store.dispatch((0, _objectSpread2.default)({}, action, {
              command: (0, _objectSpread2.default)({}, action.command, {
                error: _context.t0
              })
            }));

          case 22:
          case "end":
            return _context.stop();
        }
      }
    }, _callee, this, [[5, 19]]);
  }));

  return function sendCommand(_x, _x2) {
    return _ref2.apply(this, arguments);
  };
}();

var _default = sendCommand;
exports.default = _default;