"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _stringify = _interopRequireDefault(require("@babel/runtime/core-js/json/stringify"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _promise = _interopRequireDefault(require("@babel/runtime/core-js/promise"));

var _utils = require("./utils");

var _actions = _interopRequireDefault(require("./actions"));

var subscribeReadModel = function subscribeReadModel(_ref, action) {
  var origin = _ref.origin,
      rootPath = _ref.rootPath,
      store = _ref.store,
      readModelSubscriptions = _ref.readModelSubscriptions,
      adapter = _ref.adapter,
      orderedFetch = _ref.orderedFetch;
  var readModelName = action.readModelName,
      resolverName = action.resolverName,
      parameters = action.parameters,
      isReactive = action.isReactive;
  var subscriptionKey = "".concat(readModelName, ":").concat(resolverName);

  if (readModelSubscriptions.hasOwnProperty(subscriptionKey)) {
    return;
  }

  var fetchReadModel = function fetchReadModel() {
    if (!readModelSubscriptions.hasOwnProperty(subscriptionKey)) {
      return;
    }

    var checkSelfPromise = function checkSelfPromise(selfPromise) {
      return readModelSubscriptions.hasOwnProperty(subscriptionKey) && selfPromise === readModelSubscriptions[subscriptionKey].promise;
    };

    var selfPromise = _promise.default.resolve().then(
    /*#__PURE__*/
    (0, _asyncToGenerator2.default)(
    /*#__PURE__*/
    _regenerator.default.mark(function _callee() {
      var socketId, response, _ref3, result, timeToLive, serialId;

      return _regenerator.default.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _context.prev = 0;

              if (checkSelfPromise(selfPromise)) {
                _context.next = 3;
                break;
              }

              return _context.abrupt("return");

            case 3:
              _context.next = 5;
              return adapter.getClientId();

            case 5:
              socketId = _context.sent;
              readModelSubscriptions[subscriptionKey].socketId = socketId;

              if (checkSelfPromise(selfPromise)) {
                _context.next = 9;
                break;
              }

              return _context.abrupt("return");

            case 9:
              _context.next = 11;
              return orderedFetch((0, _utils.getRootBasedUrl)(origin, rootPath, "/api/query/".concat(readModelName, "/").concat(resolverName)), {
                method: 'POST',
                headers: {
                  'Content-Type': 'application/json'
                },
                credentials: 'same-origin',
                body: (0, _stringify.default)({
                  isReactive: isReactive,
                  socketId: socketId,
                  parameters: parameters
                })
              });

            case 11:
              response = _context.sent;

              if (response.ok) {
                _context.next = 14;
                break;
              }

              throw new Error();

            case 14:
              _context.next = 16;
              return response.json();

            case 16:
              _ref3 = _context.sent;
              result = _ref3.result;
              timeToLive = _ref3.timeToLive;
              serialId = _ref3.serialId;

              if (checkSelfPromise(selfPromise)) {
                _context.next = 22;
                break;
              }

              return _context.abrupt("return");

            case 22:
              store.dispatch(_actions.default.loadReadModelInitialState(readModelName, resolverName, result, serialId));

              if (isReactive) {
                _context.next = 25;
                break;
              }

              return _context.abrupt("return");

            case 25:
              _context.next = 27;
              return (0, _utils.delay)(timeToLive);

            case 27:
              fetchReadModel();
              _context.next = 35;
              break;

            case 30:
              _context.prev = 30;
              _context.t0 = _context["catch"](0);
              _context.next = 34;
              return (0, _utils.delay)(1000);

            case 34:
              fetchReadModel();

            case 35:
            case "end":
              return _context.stop();
          }
        }
      }, _callee, this, [[0, 30]]);
    })));

    readModelSubscriptions[subscriptionKey].promise = selfPromise;
  };

  readModelSubscriptions[subscriptionKey] = {
    promise: _promise.default.resolve(),
    refresh: fetchReadModel,
    socketId: null
  };
  fetchReadModel();
};

var _default = subscribeReadModel;
exports.default = _default;