"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _utils = require("./utils");

var _actions = _interopRequireDefault(require("./actions"));

var unsubscribeReadModel = function unsubscribeReadModel(_ref, action) {
  var origin = _ref.origin,
      rootPath = _ref.rootPath,
      store = _ref.store,
      readModelSubscriptions = _ref.readModelSubscriptions,
      orderedFetch = _ref.orderedFetch;
  var readModelName = action.readModelName,
      resolverName = action.resolverName;
  var subscriptionKey = "".concat(readModelName, ":").concat(resolverName);
  if (!readModelSubscriptions.hasOwnProperty(subscriptionKey)) return;
  var socketId = readModelSubscriptions[subscriptionKey].socketId;
  delete readModelSubscriptions[subscriptionKey];
  store.dispatch(_actions.default.dropReadModelState(readModelName, resolverName));
  if (!socketId || socketId.constructor !== String) return;
  orderedFetch((0, _utils.getRootBasedUrl)(origin, rootPath, "/api/query/".concat(readModelName, "/").concat(resolverName, "?socketId=").concat(socketId)), {
    method: 'DELETE',
    credentials: 'same-origin'
  }).catch(function () {
    return null;
  });
};

var _default = unsubscribeReadModel;
exports.default = _default;